public class WC03 {
	
	/** Stores the squared distance to linebreak */
	public final static int SPACE = 0;
	
	/** */
	public final static int BEGIN = 1;
	
	/** */
	public final static int END   = 2;
	
	// Worst case : o(N) + o(N*(N+1)/2) * ( o(N/2) + o(N) ) + 2o(N)
	//            = 3*(N*N*N + 1/4*N*N + N)	
	public static int opt(int[] l, int M) 
	{
		int n = l.length;
		int ol = (n*n+n)/2;
		int olDec = ol-1; // performance ?
		int[][] o = new int[ol][3];
		int layer, cntlayer, curroffset;
		int tmp;
		int jmax;
		int start, lstart, rstart, length;
		
		// O(N) { 3+ 4<- 1* }
		for (int i=0; i<n; i++) 
		{
			tmp = M - l[i];
			o[i][SPACE] = tmp*tmp;
			o[i][BEGIN] = -i;
			o[i][END] = -i;			
		}
		
		// { 1+ 2<- }
		layer = n-1;
		cntlayer = 1;
		curroffset = (ol - (layer*layer+layer)/2);

		// O(N*N(+1)/2
		for (int i=n; i<ol; i++) 
		{
			jmax  = n-layer;
			tmp   = 0;

					   // optimise: change only when inc layer
					   // reduces to N* these ops. use >> for x/2, too
					   // { 3+ 1<- 2*)
					   // done.
			start = i- curroffset;
			
			// O(N/2)
			// {3+ 1<-}
			// optimise break if tmp > M --> reduce to avg(Li in M)
			// but additional 1+ DONE
			for (int j=0; j<=jmax; j++) 
			{
				tmp += l[start+j];
				if (tmp > M) break;
			}
		
			// { 1+ 2<- }
			lstart = start;
			rstart = i - layer;
			
			if (tmp > M) {
				o[i][SPACE] = o[lstart][SPACE]+o[rstart][SPACE];
				o[i][BEGIN] = lstart;
				o[i][END]   = rstart;
				
				if (i==olDec) {
					// adjust last line
					// O(N) but only once -> + o(N)
					length = getLengthLastLine(rstart, o);
					o[i][SPACE] -= length;
				}
				
				// O(N)
				for (int j=0; j<jmax-1; j++)
				{
					lstart += n - j;
					rstart -= layer + j + 1;
					tmp = o[lstart][SPACE]+o[rstart][SPACE];
					
					if (i==olDec) {
						// adjust last line
						length = getLengthLastLine(rstart, o);
						tmp -= length;
					}
					
					if (tmp < o[i][SPACE]) {
						o[i][SPACE] = tmp;
						o[i][BEGIN] = lstart;
						o[i][END]   = rstart;
						// optimise: if tmp == M break, cannot find
						// a better solution
						// DONE
						if(tmp == 0) break;
					}
				}
			} 
			else {
				tmp = M - tmp;
				tmp *= tmp;
				o[i][SPACE] = tmp;
				o[i][BEGIN] = -lstart;
				o[i][END]   = -(lstart + jmax);
			}
			if (layer == cntlayer) {
				layer--;
				cntlayer = 0;
				
				// curroffset = (ol - (layer*layer+layer)/2)
				curroffset = layer*layer+layer;
				curroffset >>= 1; // div 2
				curroffset = ol - curroffset;
			}
			cntlayer++;
		}	
				
		java.util.Arrays.fill(l,0);
		
		// O(N)
		setBr(o[olDec][BEGIN], o[olDec][END], o, l);
		return o[olDec][SPACE];	
	}
	
	private static int getLengthLastLine(int rstart, int[][] o) {
		if (o[rstart][END] > 0) {
			return getLengthLastLine(o[rstart][END], o);
		} 
		return o[rstart][SPACE];
	}
	
	private static void setBr(int l, int r, int[][] o, int[] br) {
		if (r >= 0 && l >= 0) {
			if (o[r][END] > 0) {
				setBr(o[r][BEGIN],o[r][END], o, br);			
			} else {
				br[-o[r][END]] = 1;
			}
			if (o[l][END] > 0) {
				setBr(o[l][BEGIN],o[l][END], o, br);			
			} else {
				br[-o[l][END]] = 1;
			}		
		}
	}

}